<?
include ('config.inc');


//////////////////////////////////////////
//  
//  Makes a file list with directories at
//  the begining.
//
function list_files($basedir)
{
  $handle = opendir($basedir);
  $filelist = array();
  $dirlist = array();

  while ($file = readdir($handle)) 
  {
	  	$ftype = filetype($basedir.'/'.$file);      //file or dir
	  	if ($ftype!='dir')
		{   
    		//do not show index.php and directory descriptor
	    	if ("$file"!='index.php' && "$file"!='desc.dsc') 
	    	    $filelist[] = "$file";
    	}
    	else
    	{
        	//do not show '.'
	    	if ($file!=".") $dirlist[] = "$file";
		}
  }

  sort($filelist);
  sort($dirlist);
  
  $list = array_merge($dirlist,$filelist);
  closedir($handle);
  
  return $list;
}

//////////////////////////////////////////
//  
//  Counts files in the directory
//
function count_files($basedir)
{
  $handle = opendir($basedir);
  
  $i=0;
  
  while ($file = readdir($handle)) 
  	{
	  	$ftype = filetype($basedir.'/'.$file);
  	  	if ($ftype!='dir')
    	{
        	//do not count index.php and directory desc.
	    	if ("$file"!='index.php' && "$file"!='desc.dsc') $i++;  
    	}
  }
  closedir($handle);
  
  return $i;
}

//////////////////////////////////////////
//  
//  Count subdirs
//
function count_dirs($basedir)
{
  $handle = opendir($basedir);
  
  $i=0;
  
  while ($file = readdir($handle)) 
  	{
	  	$ftype = filetype($basedir.'/'.$file);
  	  	if ($ftype=='dir')
    	{
	    	$i++;
    	}
  }
  closedir($handle);
  
  return $i-2;
}

//////////////////////////////////////////
//  
//  Returns the sum of sizes of all files
//
function total_size($basedir)
{
  $handle = opendir($basedir);
  
  $i=0;
  
  while ($file = readdir($handle)) 
  	{
	  	$ftype = filetype($basedir.'/'.$file);
  	  	if ($ftype!='dir')
    	{
	    	if ("$file"!='index.php' && "$file"!='desc.dsc')$i=$i+filesize($basedir.'/'.$file);
    	}
  }
  closedir($handle);
  
  return $i;
}

//////////////////////////////////////////
//  
//  Creates a thumbnail of images in dir.
//  returns a path to the thumb.
//
function create_thumb($picture,$ext,$max)
{
    $imgsize = filesize($picture);
	if (file_exists($GLOBALS['thumb_fspath']."/th_".$picture.$imgsize.".jpg"))
	{
		return $GLOBALS['thumb']."/th_$picture$imgsize.jpg";
	}
	
	//create thumb
	if ($ext=='jpg') $src_img=imagecreatefromjpeg($picture);
	else if ($ext=='gif') $src_img=ImagecreateFromGif($picture);
		else if ($ext=='png') $src_img=ImagecreateFromPng($picture);
			else if ($ext=='jpeg') $src_img=imagecreatefromjpeg($picture);
				else return FALSE;

	$oh = imagesy($src_img);  // original height
	$ow = imagesx($src_img);  // original width

	$new_h = $oh;
	$new_w = $ow;

	if($oh > $max || $ow > $max)
	{
       $r = $oh/$ow;
       $new_h = ($oh > $ow) ? $max : $max*$r;
       $new_w = $new_h/$r;
	}
	$dst_img = ImageCreateTrueColor($new_w,$new_h);

	ImageCopyResized($dst_img, $src_img, 0,0,0,0, $new_w, $new_h, ImageSX($src_img), ImageSY($src_img));

	ImageJpeg($dst_img, $GLOBALS['thumb_fspath']."/th_".$picture.$imgsize.".jpg");
	return $GLOBALS['thumb']."/th_$picture$imgsize.jpg";
}


//////////////////////////////////////////
//  
//  Shows a table with file or dir (small)
//
function show_file_list($path,$filename)
{
	$fullpath = $path.'/'.$filename;	//dir and file
	
	$ftime = date( "d.m.y H:i:s", filemtime($fullpath));
	$ftype = filetype($fullpath);
	
		
	$table_type="file";
	//directory
	if ($ftype=='dir')
	{
		$fsize = "dir";                     //display Dir instead of filesize
		$ext = "dir";                       //directory icon
		if ($filename=='..') 
		{
    		$ext='up';     //Parent directory icon
		    $table_type = "updir";
	    }
	}
	else
	//file
	{
		$fsize = filesize($fullpath);
		$pos = strrpos($filename,'.');
		if ($pos==false) $ext="unknown";    //if the file has no extension
		else $ext = strtolower(substr($filename,$pos+1));
	}
	
	echo "<table class=\"$table_type\">\n";
	echo "<tr class=\"file\">\n";	
	
	// if file exists in ICON directory =>show image, else show common icon
	if (file_exists($GLOBALS['icons_fspath'].'/'.$ext.".png")==false) $ext='unknown'; 
	
	//cell for icon
	echo "<td class=\"ico_small\">\n";
	echo "<img src=\"".$GLOBALS['icons'].'/'.$ext.".png\" class=\"ico_small\" alt=\"".$ext."\"></td>\n";
	
	//parent dir
	if ($filename=='..') 
	{
		echo "<td class=\"file\">";
		echo "<span class=\"filename\">\n";
		echo "<a href=\"".$fullpath."\">.. (".$GLOBALS['txt']['up'].")</a>\n";
		echo "</span></td>\n";
	}
	else
	{
		echo "<td class=\"file\">";
		echo "<span class=\"filename\">\n";
		echo "<a href=\"".$fullpath."\">".$filename."</a>\n";
		echo "</span>\n";
		if (file_exists($fullpath.'/desc.dsc'))
		{
			echo "<br/>\n";
			echo "<span class=\"descr\">\n";
			include ($fullpath.'/desc.dsc');
			echo "</span>\n";
		}
		
		if ($ext=='jpeg' || $ext=='jpg' || $ext=='gif' || $ext=='png')
		{
			list($width, $height, $type, $attr) = getimagesize($fullpath);
			echo "<br/>\n";
			echo "<span class=\"descr\">\n";
			echo $ext.": ".$width."x".$height;
			echo "</span>\n";
			
			$thumb=FALSE;
			if ($width*$height<$GLOBALS['max_img_size']) 
			    $thumb = create_thumb($filename,$ext,64);
			    
			if ($thumb!=FALSE)
			{
				echo "</td>\n";
				echo "<td class=\"thumb\">\n";
				echo "<a href=\"".$fullpath."\">";
				echo "<img src=\"".$thumb."\" alt=\"\" class=\"\">";
				echo "</a>\n";
			}
		}
		
		echo "</td>\n";
		
		echo "<td class=\"filesize\">";
		echo "<span class=\"filesize\">\n";
		if ($fsize=='dir')
		{
			echo $GLOBALS['txt']['dir'];
		}
		else
		{	
			echo $fsize." B<br/>";
			if ($fsize>1024) echo ((int)($fsize/1024))." kB\n"; 
		}
		echo "</span></td>\n";
	
		echo "<td class=\"filetime\">";
		echo "<span class=\"filetime\">\n";
		echo $ftime;
		echo "</span></td>\n";
	}
	echo "</tr>\n</table>\n";
}

//////////////////////////////////////////
//  
//  Shows the whole dir.
//
function show_dir_list($path)
{
	$filelist = list_files($path);
	for ($i=0;$i<count($filelist);$i++)
	{
		show_file_list($path,$filelist[$i]);
	}
}


function show_dir($path)
{
	if ($_COOKIE['view']=="big")
	    show_dir_big($path);
	else
	    show_dir_list($path);
}
	
function print_top()
{
	$path_parts = pathinfo($_SERVER['PHP_SELF']);
	$p = explode('/',$path_parts['dirname']);
    $path="";
    for ($i=1;$i<count($p);$i++)
    {
	 	$path=$path.'/'.$p[$i];
	    echo '/ ';
	    echo "<a href=\"".$path."\">";
	    echo $p[$i];
	    echo "</a>\n";
    }
}



?>

